<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerGroups ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerGroups extends AbstractStructArrayBase
{
    /**
     * The CUSTOMER_GROUP
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\CustomerGroupType[]
     */
    public $CUSTOMER_GROUP;
    /**
     * Constructor method for ArrayOfCustomerGroups
     * @uses ArrayOfCustomerGroups::setCUSTOMER_GROUP()
     * @param \StructType\CustomerGroupType[] $cUSTOMER_GROUP
     */
    public function __construct(array $cUSTOMER_GROUP = array())
    {
        $this
            ->setCUSTOMER_GROUP($cUSTOMER_GROUP);
    }
    /**
     * Get CUSTOMER_GROUP value
     * @return \StructType\CustomerGroupType[]|null
     */
    public function getCUSTOMER_GROUP()
    {
        return $this->CUSTOMER_GROUP;
    }
    /**
     * This method is responsible for validating the values passed to the setCUSTOMER_GROUP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCUSTOMER_GROUP method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCUSTOMER_GROUPForArrayConstraintsFromSetCUSTOMER_GROUP(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerGroupsCUSTOMER_GROUPItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerGroupsCUSTOMER_GROUPItem instanceof \StructType\CustomerGroupType) {
                $invalidValues[] = is_object($arrayOfCustomerGroupsCUSTOMER_GROUPItem) ? get_class($arrayOfCustomerGroupsCUSTOMER_GROUPItem) : sprintf('%s(%s)', gettype($arrayOfCustomerGroupsCUSTOMER_GROUPItem), var_export($arrayOfCustomerGroupsCUSTOMER_GROUPItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CUSTOMER_GROUP property can only contain items of type \StructType\CustomerGroupType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CUSTOMER_GROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerGroupType[] $cUSTOMER_GROUP
     * @return \ArrayType\ArrayOfCustomerGroups
     */
    public function setCUSTOMER_GROUP(array $cUSTOMER_GROUP = array())
    {
        // validation for constraint: array
        if ('' !== ($cUSTOMER_GROUPArrayErrorMessage = self::validateCUSTOMER_GROUPForArrayConstraintsFromSetCUSTOMER_GROUP($cUSTOMER_GROUP))) {
            throw new \InvalidArgumentException($cUSTOMER_GROUPArrayErrorMessage, __LINE__);
        }
        $this->CUSTOMER_GROUP = $cUSTOMER_GROUP;
        return $this;
    }
    /**
     * Add item to CUSTOMER_GROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerGroupType $item
     * @return \ArrayType\ArrayOfCustomerGroups
     */
    public function addToCUSTOMER_GROUP(\StructType\CustomerGroupType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerGroupType) {
            throw new \InvalidArgumentException(sprintf('The CUSTOMER_GROUP property can only contain items of type \StructType\CustomerGroupType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CUSTOMER_GROUP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CustomerGroupType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CustomerGroupType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CustomerGroupType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CustomerGroupType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CustomerGroupType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CUSTOMER_GROUP
     */
    public function getAttributeName()
    {
        return 'CUSTOMER_GROUP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCustomerGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
