<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTradeProducts ArrayType
 * @subpackage Arrays
 */
class ArrayOfTradeProducts extends AbstractStructArrayBase
{
    /**
     * The PRODUCT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\TradeProduct[]
     */
    public $PRODUCT;
    /**
     * Constructor method for ArrayOfTradeProducts
     * @uses ArrayOfTradeProducts::setPRODUCT()
     * @param \StructType\TradeProduct[] $pRODUCT
     */
    public function __construct(array $pRODUCT = array())
    {
        $this
            ->setPRODUCT($pRODUCT);
    }
    /**
     * Get PRODUCT value
     * @return \StructType\TradeProduct[]|null
     */
    public function getPRODUCT()
    {
        return $this->PRODUCT;
    }
    /**
     * This method is responsible for validating the values passed to the setPRODUCT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPRODUCT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePRODUCTForArrayConstraintsFromSetPRODUCT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTradeProductsPRODUCTItem) {
            // validation for constraint: itemType
            if (!$arrayOfTradeProductsPRODUCTItem instanceof \StructType\TradeProduct) {
                $invalidValues[] = is_object($arrayOfTradeProductsPRODUCTItem) ? get_class($arrayOfTradeProductsPRODUCTItem) : sprintf('%s(%s)', gettype($arrayOfTradeProductsPRODUCTItem), var_export($arrayOfTradeProductsPRODUCTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PRODUCT property can only contain items of type \StructType\TradeProduct, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PRODUCT value
     * @throws \InvalidArgumentException
     * @param \StructType\TradeProduct[] $pRODUCT
     * @return \ArrayType\ArrayOfTradeProducts
     */
    public function setPRODUCT(array $pRODUCT = array())
    {
        // validation for constraint: array
        if ('' !== ($pRODUCTArrayErrorMessage = self::validatePRODUCTForArrayConstraintsFromSetPRODUCT($pRODUCT))) {
            throw new \InvalidArgumentException($pRODUCTArrayErrorMessage, __LINE__);
        }
        $this->PRODUCT = $pRODUCT;
        return $this;
    }
    /**
     * Add item to PRODUCT value
     * @throws \InvalidArgumentException
     * @param \StructType\TradeProduct $item
     * @return \ArrayType\ArrayOfTradeProducts
     */
    public function addToPRODUCT(\StructType\TradeProduct $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TradeProduct) {
            throw new \InvalidArgumentException(sprintf('The PRODUCT property can only contain items of type \StructType\TradeProduct, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PRODUCT[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TradeProduct|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TradeProduct|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TradeProduct|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TradeProduct|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TradeProduct|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PRODUCT
     */
    public function getAttributeName()
    {
        return 'PRODUCT';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTradeProducts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
