<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWebsites ArrayType
 * @subpackage Arrays
 */
class ArrayOfWebsites extends AbstractStructArrayBase
{
    /**
     * The WEBSITE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\WebsiteType[]
     */
    public $WEBSITE;
    /**
     * Constructor method for ArrayOfWebsites
     * @uses ArrayOfWebsites::setWEBSITE()
     * @param \StructType\WebsiteType[] $wEBSITE
     */
    public function __construct(array $wEBSITE = array())
    {
        $this
            ->setWEBSITE($wEBSITE);
    }
    /**
     * Get WEBSITE value
     * @return \StructType\WebsiteType[]|null
     */
    public function getWEBSITE()
    {
        return $this->WEBSITE;
    }
    /**
     * This method is responsible for validating the values passed to the setWEBSITE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWEBSITE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWEBSITEForArrayConstraintsFromSetWEBSITE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWebsitesWEBSITEItem) {
            // validation for constraint: itemType
            if (!$arrayOfWebsitesWEBSITEItem instanceof \StructType\WebsiteType) {
                $invalidValues[] = is_object($arrayOfWebsitesWEBSITEItem) ? get_class($arrayOfWebsitesWEBSITEItem) : sprintf('%s(%s)', gettype($arrayOfWebsitesWEBSITEItem), var_export($arrayOfWebsitesWEBSITEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WEBSITE property can only contain items of type \StructType\WebsiteType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WEBSITE value
     * @throws \InvalidArgumentException
     * @param \StructType\WebsiteType[] $wEBSITE
     * @return \ArrayType\ArrayOfWebsites
     */
    public function setWEBSITE(array $wEBSITE = array())
    {
        // validation for constraint: array
        if ('' !== ($wEBSITEArrayErrorMessage = self::validateWEBSITEForArrayConstraintsFromSetWEBSITE($wEBSITE))) {
            throw new \InvalidArgumentException($wEBSITEArrayErrorMessage, __LINE__);
        }
        $this->WEBSITE = $wEBSITE;
        return $this;
    }
    /**
     * Add item to WEBSITE value
     * @throws \InvalidArgumentException
     * @param \StructType\WebsiteType $item
     * @return \ArrayType\ArrayOfWebsites
     */
    public function addToWEBSITE(\StructType\WebsiteType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WebsiteType) {
            throw new \InvalidArgumentException(sprintf('The WEBSITE property can only contain items of type \StructType\WebsiteType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WEBSITE[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WebsiteType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WebsiteType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WebsiteType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WebsiteType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WebsiteType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WEBSITE
     */
    public function getAttributeName()
    {
        return 'WEBSITE';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfWebsites
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
