<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'WebOrdersContainerType' => '\\StructType\\WebOrdersContainerType',
            'WebOrderType' => '\\StructType\\WebOrderType',
            'OrderDetailsType' => '\\StructType\\OrderDetailsType',
            'MULTICHANNEL_SOURCE' => '\\StructType\\MULTICHANNEL_SOURCE',
            'TRACKING_INFO' => '\\StructType\\TRACKING_INFO',
            'CustomersContainerType' => '\\StructType\\CustomersContainerType',
            'CustomerType' => '\\StructType\\CustomerType',
            'SimpleCustomerType' => '\\StructType\\SimpleCustomerType',
            'ImportCustomerType' => '\\StructType\\ImportCustomerType',
            'AddressesType' => '\\StructType\\AddressesType',
            'AddressType' => '\\StructType\\AddressType',
            'OptInsType' => '\\StructType\\OptInsType',
            'OrderProductsContainerType' => '\\StructType\\OrderProductsContainerType',
            'OrderProductType' => '\\StructType\\OrderProductType',
            'CATEGORIES' => '\\StructType\\CATEGORIES',
            'PERSONALISATIONS' => '\\StructType\\PERSONALISATIONS',
            'DETAILS' => '\\StructType\\DETAILS',
            'DETAIL' => '\\StructType\\DETAIL',
            'STOCK_MESSAGE' => '\\StructType\\STOCK_MESSAGE',
            'STOCK_LOCATION' => '\\StructType\\STOCK_LOCATION',
            'BRANCH_FULFILMENT' => '\\StructType\\BRANCH_FULFILMENT',
            'PaymentType' => '\\StructType\\PaymentType',
            'TransactionBreakdownType' => '\\StructType\\TransactionBreakdownType',
            'DiscountsContainerType' => '\\StructType\\DiscountsContainerType',
            'DiscountType' => '\\StructType\\DiscountType',
            'ProductContainerType' => '\\StructType\\ProductContainerType',
            'ProductType' => '\\StructType\\ProductType',
            'SubProductsContainerType' => '\\StructType\\SubProductsContainerType',
            'SubProductType' => '\\StructType\\SubProductType',
            'ImagesType' => '\\StructType\\ImagesType',
            'CategoriesType' => '\\StructType\\CategoriesType',
            'DEPARTMENT' => '\\StructType\\DEPARTMENT',
            'DEPART_LEVEL' => '\\StructType\\DEPART_LEVEL',
            'TagsType' => '\\StructType\\TagsType',
            'TAGGROUP' => '\\StructType\\TAGGROUP',
            'UpsellingType' => '\\StructType\\UpsellingType',
            'UPSELLING_GROUP' => '\\StructType\\UPSELLING_GROUP',
            'AttributesType' => '\\StructType\\AttributesType',
            'ATTRIBUTE' => '\\StructType\\ATTRIBUTE',
            'StockContainerType' => '\\StructType\\StockContainerType',
            'STOCK' => '\\StructType\\STOCK',
            'StockLocationsType' => '\\StructType\\StockLocationsType',
            'VSAuthType' => '\\StructType\\VSAuthType',
            'ResultType' => '\\StructType\\ResultType',
            'SortOrdersContainerType' => '\\StructType\\SortOrdersContainerType',
            'SortOrderContainerType' => '\\StructType\\SortOrderContainerType',
            'SortOrderProductsContainerType' => '\\StructType\\SortOrderProductsContainerType',
            'SortOrderProductContainerType' => '\\StructType\\SortOrderProductContainerType',
            'Result' => '\\StructType\\Result',
            'ResultErrorsType' => '\\StructType\\ResultErrorsType',
            'ResultWarningsType' => '\\StructType\\ResultWarningsType',
            'ArrayOfOrders' => '\\StructType\\ArrayOfOrders',
            'ArrayOfOrdersIDs' => '\\ArrayType\\ArrayOfOrdersIDs',
            'ArrayOfOrdersRefs' => '\\ArrayType\\ArrayOfOrdersRefs',
            'ProductReferences' => '\\StructType\\ProductReferences',
            'GetData' => '\\StructType\\GetData',
            'OrderIds' => '\\StructType\\OrderIds',
            'AddCustomerGroupType' => '\\StructType\\AddCustomerGroupType',
            'ArrayOfSimpleCustomers' => '\\ArrayType\\ArrayOfSimpleCustomers',
            'TradeProduct' => '\\StructType\\TradeProduct',
            'ArrayOfTradeProducts' => '\\ArrayType\\ArrayOfTradeProducts',
            'TradeDiscountType' => '\\StructType\\TradeDiscountType',
            'CUSTOMER_GROUPS' => '\\StructType\\CUSTOMER_GROUPS',
            'CustomerGroupType' => '\\StructType\\CustomerGroupType',
            'TRADE_DISCOUNTS' => '\\StructType\\TRADE_DISCOUNTS',
            'ArrayOfCustomerGroups' => '\\ArrayType\\ArrayOfCustomerGroups',
            'ArrayOfTradeDiscounts' => '\\ArrayType\\ArrayOfTradeDiscounts',
            'AddTradeDiscountType' => '\\StructType\\AddTradeDiscountType',
            'PRODUCTS' => '\\StructType\\PRODUCTS',
            'WebsiteType' => '\\StructType\\WebsiteType',
            'ArrayOfWebsites' => '\\ArrayType\\ArrayOfWebsites',
            'OrderFraudUpdateType' => '\\StructType\\OrderFraudUpdateType',
            'NewsletterSubscriberType' => '\\StructType\\NewsletterSubscriberType',
            'subscriber_group_ids' => '\\StructType\\Subscriber_group_ids',
            'ModifyNewsletterSubscriberType' => '\\StructType\\ModifyNewsletterSubscriberType',
            'SetStockMultipleType' => '\\StructType\\SetStockMultipleType',
            'stock_level' => '\\StructType\\Stock_level',
            'stock_locations' => '\\StructType\\Stock_locations',
            'stock_location' => '\\StructType\\Stock_location_1',
        );
    }
}
