<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddressesType StructType
 * @subpackage Structs
 */
class AddressesType extends AbstractStructBase
{
    /**
     * The ADDRESS
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AddressType[]
     */
    public $ADDRESS;
    /**
     * Constructor method for AddressesType
     * @uses AddressesType::setADDRESS()
     * @param \StructType\AddressType[] $aDDRESS
     */
    public function __construct(array $aDDRESS = array())
    {
        $this
            ->setADDRESS($aDDRESS);
    }
    /**
     * Get ADDRESS value
     * @return \StructType\AddressType[]|null
     */
    public function getADDRESS()
    {
        return $this->ADDRESS;
    }
    /**
     * This method is responsible for validating the values passed to the setADDRESS method
     * This method is willingly generated in order to preserve the one-line inline validation within the setADDRESS method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateADDRESSForArrayConstraintsFromSetADDRESS(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $addressesTypeADDRESSItem) {
            // validation for constraint: itemType
            if (!$addressesTypeADDRESSItem instanceof \StructType\AddressType) {
                $invalidValues[] = is_object($addressesTypeADDRESSItem) ? get_class($addressesTypeADDRESSItem) : sprintf('%s(%s)', gettype($addressesTypeADDRESSItem), var_export($addressesTypeADDRESSItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ADDRESS property can only contain items of type \StructType\AddressType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ADDRESS value
     * @throws \InvalidArgumentException
     * @param \StructType\AddressType[] $aDDRESS
     * @return \StructType\AddressesType
     */
    public function setADDRESS(array $aDDRESS = array())
    {
        // validation for constraint: array
        if ('' !== ($aDDRESSArrayErrorMessage = self::validateADDRESSForArrayConstraintsFromSetADDRESS($aDDRESS))) {
            throw new \InvalidArgumentException($aDDRESSArrayErrorMessage, __LINE__);
        }
        $this->ADDRESS = $aDDRESS;
        return $this;
    }
    /**
     * Add item to ADDRESS value
     * @throws \InvalidArgumentException
     * @param \StructType\AddressType $item
     * @return \StructType\AddressesType
     */
    public function addToADDRESS(\StructType\AddressType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AddressType) {
            throw new \InvalidArgumentException(sprintf('The ADDRESS property can only contain items of type \StructType\AddressType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ADDRESS[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddressesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
