<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AttributesType StructType
 * @subpackage Structs
 */
class AttributesType extends AbstractStructBase
{
    /**
     * The ATTRIBUTE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ATTRIBUTE[]
     */
    public $ATTRIBUTE;
    /**
     * Constructor method for AttributesType
     * @uses AttributesType::setATTRIBUTE()
     * @param \StructType\ATTRIBUTE[] $aTTRIBUTE
     */
    public function __construct(array $aTTRIBUTE = array())
    {
        $this
            ->setATTRIBUTE($aTTRIBUTE);
    }
    /**
     * Get ATTRIBUTE value
     * @return \StructType\ATTRIBUTE[]|null
     */
    public function getATTRIBUTE()
    {
        return $this->ATTRIBUTE;
    }
    /**
     * This method is responsible for validating the values passed to the setATTRIBUTE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setATTRIBUTE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateATTRIBUTEForArrayConstraintsFromSetATTRIBUTE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $attributesTypeATTRIBUTEItem) {
            // validation for constraint: itemType
            if (!$attributesTypeATTRIBUTEItem instanceof \StructType\ATTRIBUTE) {
                $invalidValues[] = is_object($attributesTypeATTRIBUTEItem) ? get_class($attributesTypeATTRIBUTEItem) : sprintf('%s(%s)', gettype($attributesTypeATTRIBUTEItem), var_export($attributesTypeATTRIBUTEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ATTRIBUTE property can only contain items of type \StructType\ATTRIBUTE, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ATTRIBUTE value
     * @throws \InvalidArgumentException
     * @param \StructType\ATTRIBUTE[] $aTTRIBUTE
     * @return \StructType\AttributesType
     */
    public function setATTRIBUTE(array $aTTRIBUTE = array())
    {
        // validation for constraint: array
        if ('' !== ($aTTRIBUTEArrayErrorMessage = self::validateATTRIBUTEForArrayConstraintsFromSetATTRIBUTE($aTTRIBUTE))) {
            throw new \InvalidArgumentException($aTTRIBUTEArrayErrorMessage, __LINE__);
        }
        $this->ATTRIBUTE = $aTTRIBUTE;
        return $this;
    }
    /**
     * Add item to ATTRIBUTE value
     * @throws \InvalidArgumentException
     * @param \StructType\ATTRIBUTE $item
     * @return \StructType\AttributesType
     */
    public function addToATTRIBUTE(\StructType\ATTRIBUTE $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ATTRIBUTE) {
            throw new \InvalidArgumentException(sprintf('The ATTRIBUTE property can only contain items of type \StructType\ATTRIBUTE, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ATTRIBUTE[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AttributesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
