<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CUSTOMER_GROUPS StructType
 * @subpackage Structs
 */
class CUSTOMER_GROUPS extends AbstractStructBase
{
    /**
     * The CUSTOMER_GROUP_ID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $CUSTOMER_GROUP_ID;
    /**
     * Constructor method for CUSTOMER_GROUPS
     * @uses CUSTOMER_GROUPS::setCUSTOMER_GROUP_ID()
     * @param int[] $cUSTOMER_GROUP_ID
     */
    public function __construct(array $cUSTOMER_GROUP_ID = array())
    {
        $this
            ->setCUSTOMER_GROUP_ID($cUSTOMER_GROUP_ID);
    }
    /**
     * Get CUSTOMER_GROUP_ID value
     * @return int[]|null
     */
    public function getCUSTOMER_GROUP_ID()
    {
        return $this->CUSTOMER_GROUP_ID;
    }
    /**
     * This method is responsible for validating the values passed to the setCUSTOMER_GROUP_ID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCUSTOMER_GROUP_ID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCUSTOMER_GROUP_IDForArrayConstraintsFromSetCUSTOMER_GROUP_ID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cUSTOMER_GROUPSCUSTOMER_GROUP_IDItem) {
            // validation for constraint: itemType
            if (!(is_int($cUSTOMER_GROUPSCUSTOMER_GROUP_IDItem) || ctype_digit($cUSTOMER_GROUPSCUSTOMER_GROUP_IDItem))) {
                $invalidValues[] = is_object($cUSTOMER_GROUPSCUSTOMER_GROUP_IDItem) ? get_class($cUSTOMER_GROUPSCUSTOMER_GROUP_IDItem) : sprintf('%s(%s)', gettype($cUSTOMER_GROUPSCUSTOMER_GROUP_IDItem), var_export($cUSTOMER_GROUPSCUSTOMER_GROUP_IDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CUSTOMER_GROUP_ID property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CUSTOMER_GROUP_ID value
     * @throws \InvalidArgumentException
     * @param int[] $cUSTOMER_GROUP_ID
     * @return \StructType\CUSTOMER_GROUPS
     */
    public function setCUSTOMER_GROUP_ID(array $cUSTOMER_GROUP_ID = array())
    {
        // validation for constraint: array
        if ('' !== ($cUSTOMER_GROUP_IDArrayErrorMessage = self::validateCUSTOMER_GROUP_IDForArrayConstraintsFromSetCUSTOMER_GROUP_ID($cUSTOMER_GROUP_ID))) {
            throw new \InvalidArgumentException($cUSTOMER_GROUP_IDArrayErrorMessage, __LINE__);
        }
        $this->CUSTOMER_GROUP_ID = $cUSTOMER_GROUP_ID;
        return $this;
    }
    /**
     * Add item to CUSTOMER_GROUP_ID value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\CUSTOMER_GROUPS
     */
    public function addToCUSTOMER_GROUP_ID($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The CUSTOMER_GROUP_ID property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CUSTOMER_GROUP_ID[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CUSTOMER_GROUPS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
