<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CategoriesType StructType
 * @subpackage Structs
 */
class CategoriesType extends AbstractStructBase
{
    /**
     * The DEPARTMENT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DEPARTMENT[]
     */
    public $DEPARTMENT;
    /**
     * Constructor method for CategoriesType
     * @uses CategoriesType::setDEPARTMENT()
     * @param \StructType\DEPARTMENT[] $dEPARTMENT
     */
    public function __construct(array $dEPARTMENT = array())
    {
        $this
            ->setDEPARTMENT($dEPARTMENT);
    }
    /**
     * Get DEPARTMENT value
     * @return \StructType\DEPARTMENT[]|null
     */
    public function getDEPARTMENT()
    {
        return $this->DEPARTMENT;
    }
    /**
     * This method is responsible for validating the values passed to the setDEPARTMENT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDEPARTMENT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDEPARTMENTForArrayConstraintsFromSetDEPARTMENT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $categoriesTypeDEPARTMENTItem) {
            // validation for constraint: itemType
            if (!$categoriesTypeDEPARTMENTItem instanceof \StructType\DEPARTMENT) {
                $invalidValues[] = is_object($categoriesTypeDEPARTMENTItem) ? get_class($categoriesTypeDEPARTMENTItem) : sprintf('%s(%s)', gettype($categoriesTypeDEPARTMENTItem), var_export($categoriesTypeDEPARTMENTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DEPARTMENT property can only contain items of type \StructType\DEPARTMENT, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DEPARTMENT value
     * @throws \InvalidArgumentException
     * @param \StructType\DEPARTMENT[] $dEPARTMENT
     * @return \StructType\CategoriesType
     */
    public function setDEPARTMENT(array $dEPARTMENT = array())
    {
        // validation for constraint: array
        if ('' !== ($dEPARTMENTArrayErrorMessage = self::validateDEPARTMENTForArrayConstraintsFromSetDEPARTMENT($dEPARTMENT))) {
            throw new \InvalidArgumentException($dEPARTMENTArrayErrorMessage, __LINE__);
        }
        $this->DEPARTMENT = $dEPARTMENT;
        return $this;
    }
    /**
     * Add item to DEPARTMENT value
     * @throws \InvalidArgumentException
     * @param \StructType\DEPARTMENT $item
     * @return \StructType\CategoriesType
     */
    public function addToDEPARTMENT(\StructType\DEPARTMENT $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DEPARTMENT) {
            throw new \InvalidArgumentException(sprintf('The DEPARTMENT property can only contain items of type \StructType\DEPARTMENT, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DEPARTMENT[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CategoriesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
