<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomersContainerType StructType
 * @subpackage Structs
 */
class CustomersContainerType extends AbstractStructBase
{
    /**
     * The CUSTOMER
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\CustomerType[]
     */
    public $CUSTOMER;
    /**
     * Constructor method for CustomersContainerType
     * @uses CustomersContainerType::setCUSTOMER()
     * @param \StructType\CustomerType[] $cUSTOMER
     */
    public function __construct(array $cUSTOMER = array())
    {
        $this
            ->setCUSTOMER($cUSTOMER);
    }
    /**
     * Get CUSTOMER value
     * @return \StructType\CustomerType[]|null
     */
    public function getCUSTOMER()
    {
        return $this->CUSTOMER;
    }
    /**
     * This method is responsible for validating the values passed to the setCUSTOMER method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCUSTOMER method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCUSTOMERForArrayConstraintsFromSetCUSTOMER(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customersContainerTypeCUSTOMERItem) {
            // validation for constraint: itemType
            if (!$customersContainerTypeCUSTOMERItem instanceof \StructType\CustomerType) {
                $invalidValues[] = is_object($customersContainerTypeCUSTOMERItem) ? get_class($customersContainerTypeCUSTOMERItem) : sprintf('%s(%s)', gettype($customersContainerTypeCUSTOMERItem), var_export($customersContainerTypeCUSTOMERItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CUSTOMER property can only contain items of type \StructType\CustomerType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CUSTOMER value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerType[] $cUSTOMER
     * @return \StructType\CustomersContainerType
     */
    public function setCUSTOMER(array $cUSTOMER = array())
    {
        // validation for constraint: array
        if ('' !== ($cUSTOMERArrayErrorMessage = self::validateCUSTOMERForArrayConstraintsFromSetCUSTOMER($cUSTOMER))) {
            throw new \InvalidArgumentException($cUSTOMERArrayErrorMessage, __LINE__);
        }
        $this->CUSTOMER = $cUSTOMER;
        return $this;
    }
    /**
     * Add item to CUSTOMER value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerType $item
     * @return \StructType\CustomersContainerType
     */
    public function addToCUSTOMER(\StructType\CustomerType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerType) {
            throw new \InvalidArgumentException(sprintf('The CUSTOMER property can only contain items of type \StructType\CustomerType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CUSTOMER[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomersContainerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
