<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DEPARTMENT StructType
 * @subpackage Structs
 */
class DEPARTMENT extends AbstractStructBase
{
    /**
     * The DEPART_LEVEL
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\DEPART_LEVEL[]
     */
    public $DEPART_LEVEL;
    /**
     * The default
     * Meta information extracted from the WSDL
     * - fixed: true
     * @var bool
     */
    public $default;
    /**
     * Constructor method for DEPARTMENT
     * @uses DEPARTMENT::setDEPART_LEVEL()
     * @uses DEPARTMENT::setDefault()
     * @param \StructType\DEPART_LEVEL[] $dEPART_LEVEL
     * @param bool $default
     */
    public function __construct(array $dEPART_LEVEL = array(), $default = null)
    {
        $this
            ->setDEPART_LEVEL($dEPART_LEVEL)
            ->setDefault($default);
    }
    /**
     * Get DEPART_LEVEL value
     * @return \StructType\DEPART_LEVEL[]|null
     */
    public function getDEPART_LEVEL()
    {
        return $this->DEPART_LEVEL;
    }
    /**
     * This method is responsible for validating the values passed to the setDEPART_LEVEL method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDEPART_LEVEL method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDEPART_LEVELForArrayConstraintsFromSetDEPART_LEVEL(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $dEPARTMENTDEPART_LEVELItem) {
            // validation for constraint: itemType
            if (!$dEPARTMENTDEPART_LEVELItem instanceof \StructType\DEPART_LEVEL) {
                $invalidValues[] = is_object($dEPARTMENTDEPART_LEVELItem) ? get_class($dEPARTMENTDEPART_LEVELItem) : sprintf('%s(%s)', gettype($dEPARTMENTDEPART_LEVELItem), var_export($dEPARTMENTDEPART_LEVELItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DEPART_LEVEL property can only contain items of type \StructType\DEPART_LEVEL, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DEPART_LEVEL value
     * @throws \InvalidArgumentException
     * @param \StructType\DEPART_LEVEL[] $dEPART_LEVEL
     * @return \StructType\DEPARTMENT
     */
    public function setDEPART_LEVEL(array $dEPART_LEVEL = array())
    {
        // validation for constraint: array
        if ('' !== ($dEPART_LEVELArrayErrorMessage = self::validateDEPART_LEVELForArrayConstraintsFromSetDEPART_LEVEL($dEPART_LEVEL))) {
            throw new \InvalidArgumentException($dEPART_LEVELArrayErrorMessage, __LINE__);
        }
        $this->DEPART_LEVEL = $dEPART_LEVEL;
        return $this;
    }
    /**
     * Add item to DEPART_LEVEL value
     * @throws \InvalidArgumentException
     * @param \StructType\DEPART_LEVEL $item
     * @return \StructType\DEPARTMENT
     */
    public function addToDEPART_LEVEL(\StructType\DEPART_LEVEL $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DEPART_LEVEL) {
            throw new \InvalidArgumentException(sprintf('The DEPART_LEVEL property can only contain items of type \StructType\DEPART_LEVEL, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DEPART_LEVEL[] = $item;
        return $this;
    }
    /**
     * Get default value
     * @return bool|null
     */
    public function getDefault()
    {
        return $this->default;
    }
    /**
     * Set default value
     * @param bool $default
     * @return \StructType\DEPARTMENT
     */
    public function setDefault($default = null)
    {
        // validation for constraint: boolean
        if (!is_null($default) && !is_bool($default)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($default, true), gettype($default)), __LINE__);
        }
        $this->default = $default;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DEPARTMENT
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
