<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DiscountsContainerType StructType
 * @subpackage Structs
 */
class DiscountsContainerType extends AbstractStructBase
{
    /**
     * The DISCOUNT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DiscountType[]
     */
    public $DISCOUNT;
    /**
     * Constructor method for DiscountsContainerType
     * @uses DiscountsContainerType::setDISCOUNT()
     * @param \StructType\DiscountType[] $dISCOUNT
     */
    public function __construct(array $dISCOUNT = array())
    {
        $this
            ->setDISCOUNT($dISCOUNT);
    }
    /**
     * Get DISCOUNT value
     * @return \StructType\DiscountType[]|null
     */
    public function getDISCOUNT()
    {
        return $this->DISCOUNT;
    }
    /**
     * This method is responsible for validating the values passed to the setDISCOUNT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDISCOUNT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDISCOUNTForArrayConstraintsFromSetDISCOUNT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $discountsContainerTypeDISCOUNTItem) {
            // validation for constraint: itemType
            if (!$discountsContainerTypeDISCOUNTItem instanceof \StructType\DiscountType) {
                $invalidValues[] = is_object($discountsContainerTypeDISCOUNTItem) ? get_class($discountsContainerTypeDISCOUNTItem) : sprintf('%s(%s)', gettype($discountsContainerTypeDISCOUNTItem), var_export($discountsContainerTypeDISCOUNTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DISCOUNT property can only contain items of type \StructType\DiscountType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DISCOUNT value
     * @throws \InvalidArgumentException
     * @param \StructType\DiscountType[] $dISCOUNT
     * @return \StructType\DiscountsContainerType
     */
    public function setDISCOUNT(array $dISCOUNT = array())
    {
        // validation for constraint: array
        if ('' !== ($dISCOUNTArrayErrorMessage = self::validateDISCOUNTForArrayConstraintsFromSetDISCOUNT($dISCOUNT))) {
            throw new \InvalidArgumentException($dISCOUNTArrayErrorMessage, __LINE__);
        }
        $this->DISCOUNT = $dISCOUNT;
        return $this;
    }
    /**
     * Add item to DISCOUNT value
     * @throws \InvalidArgumentException
     * @param \StructType\DiscountType $item
     * @return \StructType\DiscountsContainerType
     */
    public function addToDISCOUNT(\StructType\DiscountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DiscountType) {
            throw new \InvalidArgumentException(sprintf('The DISCOUNT property can only contain items of type \StructType\DiscountType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DISCOUNT[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DiscountsContainerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
