<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImagesType StructType
 * @subpackage Structs
 */
class ImagesType extends AbstractStructBase
{
    /**
     * The IMAGE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $IMAGE;
    /**
     * Constructor method for ImagesType
     * @uses ImagesType::setIMAGE()
     * @param string[] $iMAGE
     */
    public function __construct(array $iMAGE = array())
    {
        $this
            ->setIMAGE($iMAGE);
    }
    /**
     * Get IMAGE value
     * @return string[]|null
     */
    public function getIMAGE()
    {
        return $this->IMAGE;
    }
    /**
     * This method is responsible for validating the values passed to the setIMAGE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIMAGE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIMAGEForArrayConstraintsFromSetIMAGE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $imagesTypeIMAGEItem) {
            // validation for constraint: itemType
            if (!is_string($imagesTypeIMAGEItem)) {
                $invalidValues[] = is_object($imagesTypeIMAGEItem) ? get_class($imagesTypeIMAGEItem) : sprintf('%s(%s)', gettype($imagesTypeIMAGEItem), var_export($imagesTypeIMAGEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IMAGE property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IMAGE value
     * @throws \InvalidArgumentException
     * @param string[] $iMAGE
     * @return \StructType\ImagesType
     */
    public function setIMAGE(array $iMAGE = array())
    {
        // validation for constraint: array
        if ('' !== ($iMAGEArrayErrorMessage = self::validateIMAGEForArrayConstraintsFromSetIMAGE($iMAGE))) {
            throw new \InvalidArgumentException($iMAGEArrayErrorMessage, __LINE__);
        }
        $this->IMAGE = $iMAGE;
        return $this;
    }
    /**
     * Add item to IMAGE value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\ImagesType
     */
    public function addToIMAGE($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The IMAGE property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IMAGE[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ImagesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
