<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PRODUCTS StructType
 * @subpackage Structs
 */
class PRODUCTS extends AbstractStructBase
{
    /**
     * The PRODUCT_REFERENCE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $PRODUCT_REFERENCE;
    /**
     * The PRODUCT_PRICE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $PRODUCT_PRICE;
    /**
     * Constructor method for PRODUCTS
     * @uses PRODUCTS::setPRODUCT_REFERENCE()
     * @uses PRODUCTS::setPRODUCT_PRICE()
     * @param string[] $pRODUCT_REFERENCE
     * @param string[] $pRODUCT_PRICE
     */
    public function __construct(array $pRODUCT_REFERENCE = array(), array $pRODUCT_PRICE = array())
    {
        $this
            ->setPRODUCT_REFERENCE($pRODUCT_REFERENCE)
            ->setPRODUCT_PRICE($pRODUCT_PRICE);
    }
    /**
     * Get PRODUCT_REFERENCE value
     * @return string[]|null
     */
    public function getPRODUCT_REFERENCE()
    {
        return $this->PRODUCT_REFERENCE;
    }
    /**
     * This method is responsible for validating the values passed to the setPRODUCT_REFERENCE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPRODUCT_REFERENCE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePRODUCT_REFERENCEForArrayConstraintsFromSetPRODUCT_REFERENCE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pRODUCTSPRODUCT_REFERENCEItem) {
            // validation for constraint: itemType
            if (!is_string($pRODUCTSPRODUCT_REFERENCEItem)) {
                $invalidValues[] = is_object($pRODUCTSPRODUCT_REFERENCEItem) ? get_class($pRODUCTSPRODUCT_REFERENCEItem) : sprintf('%s(%s)', gettype($pRODUCTSPRODUCT_REFERENCEItem), var_export($pRODUCTSPRODUCT_REFERENCEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PRODUCT_REFERENCE property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PRODUCT_REFERENCE value
     * @throws \InvalidArgumentException
     * @param string[] $pRODUCT_REFERENCE
     * @return \StructType\PRODUCTS
     */
    public function setPRODUCT_REFERENCE(array $pRODUCT_REFERENCE = array())
    {
        // validation for constraint: array
        if ('' !== ($pRODUCT_REFERENCEArrayErrorMessage = self::validatePRODUCT_REFERENCEForArrayConstraintsFromSetPRODUCT_REFERENCE($pRODUCT_REFERENCE))) {
            throw new \InvalidArgumentException($pRODUCT_REFERENCEArrayErrorMessage, __LINE__);
        }
        $this->PRODUCT_REFERENCE = $pRODUCT_REFERENCE;
        return $this;
    }
    /**
     * Add item to PRODUCT_REFERENCE value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\PRODUCTS
     */
    public function addToPRODUCT_REFERENCE($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The PRODUCT_REFERENCE property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PRODUCT_REFERENCE[] = $item;
        return $this;
    }
    /**
     * Get PRODUCT_PRICE value
     * @return string[]|null
     */
    public function getPRODUCT_PRICE()
    {
        return $this->PRODUCT_PRICE;
    }
    /**
     * This method is responsible for validating the values passed to the setPRODUCT_PRICE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPRODUCT_PRICE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePRODUCT_PRICEForArrayConstraintsFromSetPRODUCT_PRICE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pRODUCTSPRODUCT_PRICEItem) {
            // validation for constraint: itemType
            if (!is_string($pRODUCTSPRODUCT_PRICEItem)) {
                $invalidValues[] = is_object($pRODUCTSPRODUCT_PRICEItem) ? get_class($pRODUCTSPRODUCT_PRICEItem) : sprintf('%s(%s)', gettype($pRODUCTSPRODUCT_PRICEItem), var_export($pRODUCTSPRODUCT_PRICEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PRODUCT_PRICE property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PRODUCT_PRICE value
     * @throws \InvalidArgumentException
     * @param string[] $pRODUCT_PRICE
     * @return \StructType\PRODUCTS
     */
    public function setPRODUCT_PRICE(array $pRODUCT_PRICE = array())
    {
        // validation for constraint: array
        if ('' !== ($pRODUCT_PRICEArrayErrorMessage = self::validatePRODUCT_PRICEForArrayConstraintsFromSetPRODUCT_PRICE($pRODUCT_PRICE))) {
            throw new \InvalidArgumentException($pRODUCT_PRICEArrayErrorMessage, __LINE__);
        }
        $this->PRODUCT_PRICE = $pRODUCT_PRICE;
        return $this;
    }
    /**
     * Add item to PRODUCT_PRICE value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\PRODUCTS
     */
    public function addToPRODUCT_PRICE($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The PRODUCT_PRICE property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PRODUCT_PRICE[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PRODUCTS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
