<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for STOCK_LOCATION StructType
 * @subpackage Structs
 */
class STOCK_LOCATION extends AbstractStructBase
{
    /**
     * The STOCK_LOCATION_ID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $STOCK_LOCATION_ID;
    /**
     * The STOCK_LOCATION
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $STOCK_LOCATION;
    /**
     * The NAME
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NAME;
    /**
     * The LEVEL
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $LEVEL;
    /**
     * The CHILD_STOCK_LOCATIONS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\StockLocationsType
     */
    public $CHILD_STOCK_LOCATIONS;
    /**
     * Constructor method for STOCK_LOCATION
     * @uses STOCK_LOCATION::setSTOCK_LOCATION_ID()
     * @uses STOCK_LOCATION::setSTOCK_LOCATION()
     * @uses STOCK_LOCATION::setNAME()
     * @uses STOCK_LOCATION::setLEVEL()
     * @uses STOCK_LOCATION::setCHILD_STOCK_LOCATIONS()
     * @param int $sTOCK_LOCATION_ID
     * @param string $sTOCK_LOCATION
     * @param string $nAME
     * @param int $lEVEL
     * @param \StructType\StockLocationsType $cHILD_STOCK_LOCATIONS
     */
    public function __construct($sTOCK_LOCATION_ID = null, $sTOCK_LOCATION = null, $nAME = null, $lEVEL = null, \StructType\StockLocationsType $cHILD_STOCK_LOCATIONS = null)
    {
        $this
            ->setSTOCK_LOCATION_ID($sTOCK_LOCATION_ID)
            ->setSTOCK_LOCATION($sTOCK_LOCATION)
            ->setNAME($nAME)
            ->setLEVEL($lEVEL)
            ->setCHILD_STOCK_LOCATIONS($cHILD_STOCK_LOCATIONS);
    }
    /**
     * Get STOCK_LOCATION_ID value
     * @return int|null
     */
    public function getSTOCK_LOCATION_ID()
    {
        return $this->STOCK_LOCATION_ID;
    }
    /**
     * Set STOCK_LOCATION_ID value
     * @param int $sTOCK_LOCATION_ID
     * @return \StructType\STOCK_LOCATION
     */
    public function setSTOCK_LOCATION_ID($sTOCK_LOCATION_ID = null)
    {
        // validation for constraint: int
        if (!is_null($sTOCK_LOCATION_ID) && !(is_int($sTOCK_LOCATION_ID) || ctype_digit($sTOCK_LOCATION_ID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sTOCK_LOCATION_ID, true), gettype($sTOCK_LOCATION_ID)), __LINE__);
        }
        $this->STOCK_LOCATION_ID = $sTOCK_LOCATION_ID;
        return $this;
    }
    /**
     * Get STOCK_LOCATION value
     * @return string|null
     */
    public function getSTOCK_LOCATION()
    {
        return $this->STOCK_LOCATION;
    }
    /**
     * Set STOCK_LOCATION value
     * @param string $sTOCK_LOCATION
     * @return \StructType\STOCK_LOCATION
     */
    public function setSTOCK_LOCATION($sTOCK_LOCATION = null)
    {
        // validation for constraint: string
        if (!is_null($sTOCK_LOCATION) && !is_string($sTOCK_LOCATION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sTOCK_LOCATION, true), gettype($sTOCK_LOCATION)), __LINE__);
        }
        $this->STOCK_LOCATION = $sTOCK_LOCATION;
        return $this;
    }
    /**
     * Get NAME value
     * @return string|null
     */
    public function getNAME()
    {
        return $this->NAME;
    }
    /**
     * Set NAME value
     * @param string $nAME
     * @return \StructType\STOCK_LOCATION
     */
    public function setNAME($nAME = null)
    {
        // validation for constraint: string
        if (!is_null($nAME) && !is_string($nAME)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nAME, true), gettype($nAME)), __LINE__);
        }
        $this->NAME = $nAME;
        return $this;
    }
    /**
     * Get LEVEL value
     * @return int|null
     */
    public function getLEVEL()
    {
        return $this->LEVEL;
    }
    /**
     * Set LEVEL value
     * @param int $lEVEL
     * @return \StructType\STOCK_LOCATION
     */
    public function setLEVEL($lEVEL = null)
    {
        // validation for constraint: int
        if (!is_null($lEVEL) && !(is_int($lEVEL) || ctype_digit($lEVEL))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lEVEL, true), gettype($lEVEL)), __LINE__);
        }
        $this->LEVEL = $lEVEL;
        return $this;
    }
    /**
     * Get CHILD_STOCK_LOCATIONS value
     * @return \StructType\StockLocationsType|null
     */
    public function getCHILD_STOCK_LOCATIONS()
    {
        return $this->CHILD_STOCK_LOCATIONS;
    }
    /**
     * Set CHILD_STOCK_LOCATIONS value
     * @param \StructType\StockLocationsType $cHILD_STOCK_LOCATIONS
     * @return \StructType\STOCK_LOCATION
     */
    public function setCHILD_STOCK_LOCATIONS(\StructType\StockLocationsType $cHILD_STOCK_LOCATIONS = null)
    {
        $this->CHILD_STOCK_LOCATIONS = $cHILD_STOCK_LOCATIONS;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\STOCK_LOCATION
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
