<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SortOrderContainerType StructType
 * @subpackage Structs
 */
class SortOrderContainerType extends AbstractStructBase
{
    /**
     * The TYPE
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $TYPE;
    /**
     * The MATCH_TYPE
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MATCH_TYPE;
    /**
     * The SORTING
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SORTING;
    /**
     * The PRODUCTS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SortOrderProductsContainerType
     */
    public $PRODUCTS;
    /**
     * Constructor method for SortOrderContainerType
     * @uses SortOrderContainerType::setTYPE()
     * @uses SortOrderContainerType::setMATCH_TYPE()
     * @uses SortOrderContainerType::setSORTING()
     * @uses SortOrderContainerType::setPRODUCTS()
     * @param string $tYPE
     * @param string $mATCH_TYPE
     * @param string $sORTING
     * @param \StructType\SortOrderProductsContainerType $pRODUCTS
     */
    public function __construct($tYPE = null, $mATCH_TYPE = null, $sORTING = null, \StructType\SortOrderProductsContainerType $pRODUCTS = null)
    {
        $this
            ->setTYPE($tYPE)
            ->setMATCH_TYPE($mATCH_TYPE)
            ->setSORTING($sORTING)
            ->setPRODUCTS($pRODUCTS);
    }
    /**
     * Get TYPE value
     * @return string
     */
    public function getTYPE()
    {
        return $this->TYPE;
    }
    /**
     * Set TYPE value
     * @param string $tYPE
     * @return \StructType\SortOrderContainerType
     */
    public function setTYPE($tYPE = null)
    {
        // validation for constraint: string
        if (!is_null($tYPE) && !is_string($tYPE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tYPE, true), gettype($tYPE)), __LINE__);
        }
        $this->TYPE = $tYPE;
        return $this;
    }
    /**
     * Get MATCH_TYPE value
     * @return string|null
     */
    public function getMATCH_TYPE()
    {
        return $this->MATCH_TYPE;
    }
    /**
     * Set MATCH_TYPE value
     * @param string $mATCH_TYPE
     * @return \StructType\SortOrderContainerType
     */
    public function setMATCH_TYPE($mATCH_TYPE = null)
    {
        // validation for constraint: string
        if (!is_null($mATCH_TYPE) && !is_string($mATCH_TYPE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mATCH_TYPE, true), gettype($mATCH_TYPE)), __LINE__);
        }
        $this->MATCH_TYPE = $mATCH_TYPE;
        return $this;
    }
    /**
     * Get SORTING value
     * @return string|null
     */
    public function getSORTING()
    {
        return $this->SORTING;
    }
    /**
     * Set SORTING value
     * @param string $sORTING
     * @return \StructType\SortOrderContainerType
     */
    public function setSORTING($sORTING = null)
    {
        // validation for constraint: string
        if (!is_null($sORTING) && !is_string($sORTING)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sORTING, true), gettype($sORTING)), __LINE__);
        }
        $this->SORTING = $sORTING;
        return $this;
    }
    /**
     * Get PRODUCTS value
     * @return \StructType\SortOrderProductsContainerType|null
     */
    public function getPRODUCTS()
    {
        return $this->PRODUCTS;
    }
    /**
     * Set PRODUCTS value
     * @param \StructType\SortOrderProductsContainerType $pRODUCTS
     * @return \StructType\SortOrderContainerType
     */
    public function setPRODUCTS(\StructType\SortOrderProductsContainerType $pRODUCTS = null)
    {
        $this->PRODUCTS = $pRODUCTS;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SortOrderContainerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
