<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SortOrderProductsContainerType StructType
 * @subpackage Structs
 */
class SortOrderProductsContainerType extends AbstractStructBase
{
    /**
     * The PRODUCT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SortOrderProductContainerType[]
     */
    public $PRODUCT;
    /**
     * Constructor method for SortOrderProductsContainerType
     * @uses SortOrderProductsContainerType::setPRODUCT()
     * @param \StructType\SortOrderProductContainerType[] $pRODUCT
     */
    public function __construct(array $pRODUCT = array())
    {
        $this
            ->setPRODUCT($pRODUCT);
    }
    /**
     * Get PRODUCT value
     * @return \StructType\SortOrderProductContainerType[]|null
     */
    public function getPRODUCT()
    {
        return $this->PRODUCT;
    }
    /**
     * This method is responsible for validating the values passed to the setPRODUCT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPRODUCT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePRODUCTForArrayConstraintsFromSetPRODUCT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $sortOrderProductsContainerTypePRODUCTItem) {
            // validation for constraint: itemType
            if (!$sortOrderProductsContainerTypePRODUCTItem instanceof \StructType\SortOrderProductContainerType) {
                $invalidValues[] = is_object($sortOrderProductsContainerTypePRODUCTItem) ? get_class($sortOrderProductsContainerTypePRODUCTItem) : sprintf('%s(%s)', gettype($sortOrderProductsContainerTypePRODUCTItem), var_export($sortOrderProductsContainerTypePRODUCTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PRODUCT property can only contain items of type \StructType\SortOrderProductContainerType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PRODUCT value
     * @throws \InvalidArgumentException
     * @param \StructType\SortOrderProductContainerType[] $pRODUCT
     * @return \StructType\SortOrderProductsContainerType
     */
    public function setPRODUCT(array $pRODUCT = array())
    {
        // validation for constraint: array
        if ('' !== ($pRODUCTArrayErrorMessage = self::validatePRODUCTForArrayConstraintsFromSetPRODUCT($pRODUCT))) {
            throw new \InvalidArgumentException($pRODUCTArrayErrorMessage, __LINE__);
        }
        $this->PRODUCT = $pRODUCT;
        return $this;
    }
    /**
     * Add item to PRODUCT value
     * @throws \InvalidArgumentException
     * @param \StructType\SortOrderProductContainerType $item
     * @return \StructType\SortOrderProductsContainerType
     */
    public function addToPRODUCT(\StructType\SortOrderProductContainerType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SortOrderProductContainerType) {
            throw new \InvalidArgumentException(sprintf('The PRODUCT property can only contain items of type \StructType\SortOrderProductContainerType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PRODUCT[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SortOrderProductsContainerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
