<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SortOrdersContainerType StructType
 * @subpackage Structs
 */
class SortOrdersContainerType extends AbstractStructBase
{
    /**
     * The SORT_ORDER
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SortOrderContainerType[]
     */
    public $SORT_ORDER;
    /**
     * Constructor method for SortOrdersContainerType
     * @uses SortOrdersContainerType::setSORT_ORDER()
     * @param \StructType\SortOrderContainerType[] $sORT_ORDER
     */
    public function __construct(array $sORT_ORDER = array())
    {
        $this
            ->setSORT_ORDER($sORT_ORDER);
    }
    /**
     * Get SORT_ORDER value
     * @return \StructType\SortOrderContainerType[]|null
     */
    public function getSORT_ORDER()
    {
        return $this->SORT_ORDER;
    }
    /**
     * This method is responsible for validating the values passed to the setSORT_ORDER method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSORT_ORDER method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSORT_ORDERForArrayConstraintsFromSetSORT_ORDER(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $sortOrdersContainerTypeSORT_ORDERItem) {
            // validation for constraint: itemType
            if (!$sortOrdersContainerTypeSORT_ORDERItem instanceof \StructType\SortOrderContainerType) {
                $invalidValues[] = is_object($sortOrdersContainerTypeSORT_ORDERItem) ? get_class($sortOrdersContainerTypeSORT_ORDERItem) : sprintf('%s(%s)', gettype($sortOrdersContainerTypeSORT_ORDERItem), var_export($sortOrdersContainerTypeSORT_ORDERItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SORT_ORDER property can only contain items of type \StructType\SortOrderContainerType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SORT_ORDER value
     * @throws \InvalidArgumentException
     * @param \StructType\SortOrderContainerType[] $sORT_ORDER
     * @return \StructType\SortOrdersContainerType
     */
    public function setSORT_ORDER(array $sORT_ORDER = array())
    {
        // validation for constraint: array
        if ('' !== ($sORT_ORDERArrayErrorMessage = self::validateSORT_ORDERForArrayConstraintsFromSetSORT_ORDER($sORT_ORDER))) {
            throw new \InvalidArgumentException($sORT_ORDERArrayErrorMessage, __LINE__);
        }
        $this->SORT_ORDER = $sORT_ORDER;
        return $this;
    }
    /**
     * Add item to SORT_ORDER value
     * @throws \InvalidArgumentException
     * @param \StructType\SortOrderContainerType $item
     * @return \StructType\SortOrdersContainerType
     */
    public function addToSORT_ORDER(\StructType\SortOrderContainerType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SortOrderContainerType) {
            throw new \InvalidArgumentException(sprintf('The SORT_ORDER property can only contain items of type \StructType\SortOrderContainerType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SORT_ORDER[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SortOrdersContainerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
