<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for stock_locations StructType
 * @subpackage Structs
 */
class Stock_locations extends AbstractStructBase
{
    /**
     * The stock_location
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\Stock_location_1[]
     */
    public $stock_location;
    /**
     * Constructor method for stock_locations
     * @uses Stock_locations::setStock_location()
     * @param \StructType\Stock_location_1[] $stock_location
     */
    public function __construct(array $stock_location = array())
    {
        $this
            ->setStock_location($stock_location);
    }
    /**
     * Get stock_location value
     * @return \StructType\Stock_location_1[]
     */
    public function getStock_location()
    {
        return $this->stock_location;
    }
    /**
     * This method is responsible for validating the values passed to the setStock_location method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStock_location method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStock_locationForArrayConstraintsFromSetStock_location(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $stock_locationsStock_locationItem) {
            // validation for constraint: itemType
            if (!$stock_locationsStock_locationItem instanceof \StructType\Stock_location_1) {
                $invalidValues[] = is_object($stock_locationsStock_locationItem) ? get_class($stock_locationsStock_locationItem) : sprintf('%s(%s)', gettype($stock_locationsStock_locationItem), var_export($stock_locationsStock_locationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The stock_location property can only contain items of type \StructType\Stock_location_1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set stock_location value
     * @throws \InvalidArgumentException
     * @param \StructType\Stock_location_1[] $stock_location
     * @return \StructType\Stock_locations
     */
    public function setStock_location(array $stock_location = array())
    {
        // validation for constraint: array
        if ('' !== ($stock_locationArrayErrorMessage = self::validateStock_locationForArrayConstraintsFromSetStock_location($stock_location))) {
            throw new \InvalidArgumentException($stock_locationArrayErrorMessage, __LINE__);
        }
        $this->stock_location = $stock_location;
        return $this;
    }
    /**
     * Add item to stock_location value
     * @throws \InvalidArgumentException
     * @param \StructType\Stock_location_1 $item
     * @return \StructType\Stock_locations
     */
    public function addToStock_location(\StructType\Stock_location_1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Stock_location_1) {
            throw new \InvalidArgumentException(sprintf('The stock_location property can only contain items of type \StructType\Stock_location_1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->stock_location[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Stock_locations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
