<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubProductsContainerType StructType
 * @subpackage Structs
 */
class SubProductsContainerType extends AbstractStructBase
{
    /**
     * The SUBPRODUCT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SubProductType[]
     */
    public $SUBPRODUCT;
    /**
     * Constructor method for SubProductsContainerType
     * @uses SubProductsContainerType::setSUBPRODUCT()
     * @param \StructType\SubProductType[] $sUBPRODUCT
     */
    public function __construct(array $sUBPRODUCT = array())
    {
        $this
            ->setSUBPRODUCT($sUBPRODUCT);
    }
    /**
     * Get SUBPRODUCT value
     * @return \StructType\SubProductType[]|null
     */
    public function getSUBPRODUCT()
    {
        return $this->SUBPRODUCT;
    }
    /**
     * This method is responsible for validating the values passed to the setSUBPRODUCT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSUBPRODUCT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSUBPRODUCTForArrayConstraintsFromSetSUBPRODUCT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $subProductsContainerTypeSUBPRODUCTItem) {
            // validation for constraint: itemType
            if (!$subProductsContainerTypeSUBPRODUCTItem instanceof \StructType\SubProductType) {
                $invalidValues[] = is_object($subProductsContainerTypeSUBPRODUCTItem) ? get_class($subProductsContainerTypeSUBPRODUCTItem) : sprintf('%s(%s)', gettype($subProductsContainerTypeSUBPRODUCTItem), var_export($subProductsContainerTypeSUBPRODUCTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SUBPRODUCT property can only contain items of type \StructType\SubProductType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SUBPRODUCT value
     * @throws \InvalidArgumentException
     * @param \StructType\SubProductType[] $sUBPRODUCT
     * @return \StructType\SubProductsContainerType
     */
    public function setSUBPRODUCT(array $sUBPRODUCT = array())
    {
        // validation for constraint: array
        if ('' !== ($sUBPRODUCTArrayErrorMessage = self::validateSUBPRODUCTForArrayConstraintsFromSetSUBPRODUCT($sUBPRODUCT))) {
            throw new \InvalidArgumentException($sUBPRODUCTArrayErrorMessage, __LINE__);
        }
        $this->SUBPRODUCT = $sUBPRODUCT;
        return $this;
    }
    /**
     * Add item to SUBPRODUCT value
     * @throws \InvalidArgumentException
     * @param \StructType\SubProductType $item
     * @return \StructType\SubProductsContainerType
     */
    public function addToSUBPRODUCT(\StructType\SubProductType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubProductType) {
            throw new \InvalidArgumentException(sprintf('The SUBPRODUCT property can only contain items of type \StructType\SubProductType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SUBPRODUCT[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubProductsContainerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
