<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subscriber_group_ids StructType
 * @subpackage Structs
 */
class Subscriber_group_ids extends AbstractStructBase
{
    /**
     * The subscriber_group_id
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var int[]
     */
    public $subscriber_group_id;
    /**
     * Constructor method for subscriber_group_ids
     * @uses Subscriber_group_ids::setSubscriber_group_id()
     * @param int[] $subscriber_group_id
     */
    public function __construct(array $subscriber_group_id = array())
    {
        $this
            ->setSubscriber_group_id($subscriber_group_id);
    }
    /**
     * Get subscriber_group_id value
     * @return int[]|null
     */
    public function getSubscriber_group_id()
    {
        return $this->subscriber_group_id;
    }
    /**
     * This method is responsible for validating the values passed to the setSubscriber_group_id method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubscriber_group_id method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubscriber_group_idForArrayConstraintsFromSetSubscriber_group_id(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $subscriber_group_idsSubscriber_group_idItem) {
            // validation for constraint: itemType
            if (!(is_int($subscriber_group_idsSubscriber_group_idItem) || ctype_digit($subscriber_group_idsSubscriber_group_idItem))) {
                $invalidValues[] = is_object($subscriber_group_idsSubscriber_group_idItem) ? get_class($subscriber_group_idsSubscriber_group_idItem) : sprintf('%s(%s)', gettype($subscriber_group_idsSubscriber_group_idItem), var_export($subscriber_group_idsSubscriber_group_idItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The subscriber_group_id property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set subscriber_group_id value
     * @throws \InvalidArgumentException
     * @param int[] $subscriber_group_id
     * @return \StructType\Subscriber_group_ids
     */
    public function setSubscriber_group_id(array $subscriber_group_id = array())
    {
        // validation for constraint: array
        if ('' !== ($subscriber_group_idArrayErrorMessage = self::validateSubscriber_group_idForArrayConstraintsFromSetSubscriber_group_id($subscriber_group_id))) {
            throw new \InvalidArgumentException($subscriber_group_idArrayErrorMessage, __LINE__);
        }
        $this->subscriber_group_id = $subscriber_group_id;
        return $this;
    }
    /**
     * Add item to subscriber_group_id value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Subscriber_group_ids
     */
    public function addToSubscriber_group_id($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The subscriber_group_id property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->subscriber_group_id[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Subscriber_group_ids
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
