<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TRADE_DISCOUNTS StructType
 * @subpackage Structs
 */
class TRADE_DISCOUNTS extends AbstractStructBase
{
    /**
     * The TRADE_DISCOUNT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\TradeDiscountType[]
     */
    public $TRADE_DISCOUNT;
    /**
     * Constructor method for TRADE_DISCOUNTS
     * @uses TRADE_DISCOUNTS::setTRADE_DISCOUNT()
     * @param \StructType\TradeDiscountType[] $tRADE_DISCOUNT
     */
    public function __construct(array $tRADE_DISCOUNT = array())
    {
        $this
            ->setTRADE_DISCOUNT($tRADE_DISCOUNT);
    }
    /**
     * Get TRADE_DISCOUNT value
     * @return \StructType\TradeDiscountType[]|null
     */
    public function getTRADE_DISCOUNT()
    {
        return $this->TRADE_DISCOUNT;
    }
    /**
     * This method is responsible for validating the values passed to the setTRADE_DISCOUNT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTRADE_DISCOUNT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTRADE_DISCOUNTForArrayConstraintsFromSetTRADE_DISCOUNT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tRADE_DISCOUNTSTRADE_DISCOUNTItem) {
            // validation for constraint: itemType
            if (!$tRADE_DISCOUNTSTRADE_DISCOUNTItem instanceof \StructType\TradeDiscountType) {
                $invalidValues[] = is_object($tRADE_DISCOUNTSTRADE_DISCOUNTItem) ? get_class($tRADE_DISCOUNTSTRADE_DISCOUNTItem) : sprintf('%s(%s)', gettype($tRADE_DISCOUNTSTRADE_DISCOUNTItem), var_export($tRADE_DISCOUNTSTRADE_DISCOUNTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TRADE_DISCOUNT property can only contain items of type \StructType\TradeDiscountType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TRADE_DISCOUNT value
     * @throws \InvalidArgumentException
     * @param \StructType\TradeDiscountType[] $tRADE_DISCOUNT
     * @return \StructType\TRADE_DISCOUNTS
     */
    public function setTRADE_DISCOUNT(array $tRADE_DISCOUNT = array())
    {
        // validation for constraint: array
        if ('' !== ($tRADE_DISCOUNTArrayErrorMessage = self::validateTRADE_DISCOUNTForArrayConstraintsFromSetTRADE_DISCOUNT($tRADE_DISCOUNT))) {
            throw new \InvalidArgumentException($tRADE_DISCOUNTArrayErrorMessage, __LINE__);
        }
        $this->TRADE_DISCOUNT = $tRADE_DISCOUNT;
        return $this;
    }
    /**
     * Add item to TRADE_DISCOUNT value
     * @throws \InvalidArgumentException
     * @param \StructType\TradeDiscountType $item
     * @return \StructType\TRADE_DISCOUNTS
     */
    public function addToTRADE_DISCOUNT(\StructType\TradeDiscountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TradeDiscountType) {
            throw new \InvalidArgumentException(sprintf('The TRADE_DISCOUNT property can only contain items of type \StructType\TradeDiscountType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TRADE_DISCOUNT[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TRADE_DISCOUNTS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
