<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TagsType StructType
 * @subpackage Structs
 */
class TagsType extends AbstractStructBase
{
    /**
     * The TAGGROUP
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TAGGROUP[]
     */
    public $TAGGROUP;
    /**
     * Constructor method for TagsType
     * @uses TagsType::setTAGGROUP()
     * @param \StructType\TAGGROUP[] $tAGGROUP
     */
    public function __construct(array $tAGGROUP = array())
    {
        $this
            ->setTAGGROUP($tAGGROUP);
    }
    /**
     * Get TAGGROUP value
     * @return \StructType\TAGGROUP[]|null
     */
    public function getTAGGROUP()
    {
        return $this->TAGGROUP;
    }
    /**
     * This method is responsible for validating the values passed to the setTAGGROUP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTAGGROUP method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTAGGROUPForArrayConstraintsFromSetTAGGROUP(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tagsTypeTAGGROUPItem) {
            // validation for constraint: itemType
            if (!$tagsTypeTAGGROUPItem instanceof \StructType\TAGGROUP) {
                $invalidValues[] = is_object($tagsTypeTAGGROUPItem) ? get_class($tagsTypeTAGGROUPItem) : sprintf('%s(%s)', gettype($tagsTypeTAGGROUPItem), var_export($tagsTypeTAGGROUPItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TAGGROUP property can only contain items of type \StructType\TAGGROUP, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TAGGROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\TAGGROUP[] $tAGGROUP
     * @return \StructType\TagsType
     */
    public function setTAGGROUP(array $tAGGROUP = array())
    {
        // validation for constraint: array
        if ('' !== ($tAGGROUPArrayErrorMessage = self::validateTAGGROUPForArrayConstraintsFromSetTAGGROUP($tAGGROUP))) {
            throw new \InvalidArgumentException($tAGGROUPArrayErrorMessage, __LINE__);
        }
        $this->TAGGROUP = $tAGGROUP;
        return $this;
    }
    /**
     * Add item to TAGGROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\TAGGROUP $item
     * @return \StructType\TagsType
     */
    public function addToTAGGROUP(\StructType\TAGGROUP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TAGGROUP) {
            throw new \InvalidArgumentException(sprintf('The TAGGROUP property can only contain items of type \StructType\TAGGROUP, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TAGGROUP[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TagsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
