<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransactionBreakdownType StructType
 * @subpackage Structs
 */
class TransactionBreakdownType extends AbstractStructBase
{
    /**
     * The PAYMENT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaymentType[]
     */
    public $PAYMENT;
    /**
     * Constructor method for TransactionBreakdownType
     * @uses TransactionBreakdownType::setPAYMENT()
     * @param \StructType\PaymentType[] $pAYMENT
     */
    public function __construct(array $pAYMENT = array())
    {
        $this
            ->setPAYMENT($pAYMENT);
    }
    /**
     * Get PAYMENT value
     * @return \StructType\PaymentType[]|null
     */
    public function getPAYMENT()
    {
        return $this->PAYMENT;
    }
    /**
     * This method is responsible for validating the values passed to the setPAYMENT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPAYMENT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePAYMENTForArrayConstraintsFromSetPAYMENT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $transactionBreakdownTypePAYMENTItem) {
            // validation for constraint: itemType
            if (!$transactionBreakdownTypePAYMENTItem instanceof \StructType\PaymentType) {
                $invalidValues[] = is_object($transactionBreakdownTypePAYMENTItem) ? get_class($transactionBreakdownTypePAYMENTItem) : sprintf('%s(%s)', gettype($transactionBreakdownTypePAYMENTItem), var_export($transactionBreakdownTypePAYMENTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PAYMENT property can only contain items of type \StructType\PaymentType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PAYMENT value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentType[] $pAYMENT
     * @return \StructType\TransactionBreakdownType
     */
    public function setPAYMENT(array $pAYMENT = array())
    {
        // validation for constraint: array
        if ('' !== ($pAYMENTArrayErrorMessage = self::validatePAYMENTForArrayConstraintsFromSetPAYMENT($pAYMENT))) {
            throw new \InvalidArgumentException($pAYMENTArrayErrorMessage, __LINE__);
        }
        $this->PAYMENT = $pAYMENT;
        return $this;
    }
    /**
     * Add item to PAYMENT value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentType $item
     * @return \StructType\TransactionBreakdownType
     */
    public function addToPAYMENT(\StructType\PaymentType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaymentType) {
            throw new \InvalidArgumentException(sprintf('The PAYMENT property can only contain items of type \StructType\PaymentType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PAYMENT[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TransactionBreakdownType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
