<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpsellingType StructType
 * @subpackage Structs
 */
class UpsellingType extends AbstractStructBase
{
    /**
     * The UPSELLING_GROUP
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UPSELLING_GROUP[]
     */
    public $UPSELLING_GROUP;
    /**
     * Constructor method for UpsellingType
     * @uses UpsellingType::setUPSELLING_GROUP()
     * @param \StructType\UPSELLING_GROUP[] $uPSELLING_GROUP
     */
    public function __construct(array $uPSELLING_GROUP = array())
    {
        $this
            ->setUPSELLING_GROUP($uPSELLING_GROUP);
    }
    /**
     * Get UPSELLING_GROUP value
     * @return \StructType\UPSELLING_GROUP[]|null
     */
    public function getUPSELLING_GROUP()
    {
        return $this->UPSELLING_GROUP;
    }
    /**
     * This method is responsible for validating the values passed to the setUPSELLING_GROUP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUPSELLING_GROUP method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUPSELLING_GROUPForArrayConstraintsFromSetUPSELLING_GROUP(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $upsellingTypeUPSELLING_GROUPItem) {
            // validation for constraint: itemType
            if (!$upsellingTypeUPSELLING_GROUPItem instanceof \StructType\UPSELLING_GROUP) {
                $invalidValues[] = is_object($upsellingTypeUPSELLING_GROUPItem) ? get_class($upsellingTypeUPSELLING_GROUPItem) : sprintf('%s(%s)', gettype($upsellingTypeUPSELLING_GROUPItem), var_export($upsellingTypeUPSELLING_GROUPItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UPSELLING_GROUP property can only contain items of type \StructType\UPSELLING_GROUP, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UPSELLING_GROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\UPSELLING_GROUP[] $uPSELLING_GROUP
     * @return \StructType\UpsellingType
     */
    public function setUPSELLING_GROUP(array $uPSELLING_GROUP = array())
    {
        // validation for constraint: array
        if ('' !== ($uPSELLING_GROUPArrayErrorMessage = self::validateUPSELLING_GROUPForArrayConstraintsFromSetUPSELLING_GROUP($uPSELLING_GROUP))) {
            throw new \InvalidArgumentException($uPSELLING_GROUPArrayErrorMessage, __LINE__);
        }
        $this->UPSELLING_GROUP = $uPSELLING_GROUP;
        return $this;
    }
    /**
     * Add item to UPSELLING_GROUP value
     * @throws \InvalidArgumentException
     * @param \StructType\UPSELLING_GROUP $item
     * @return \StructType\UpsellingType
     */
    public function addToUPSELLING_GROUP(\StructType\UPSELLING_GROUP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UPSELLING_GROUP) {
            throw new \InvalidArgumentException(sprintf('The UPSELLING_GROUP property can only contain items of type \StructType\UPSELLING_GROUP, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UPSELLING_GROUP[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpsellingType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
