<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WebOrdersContainerType StructType
 * @subpackage Structs
 */
class WebOrdersContainerType extends AbstractStructBase
{
    /**
     * The WEB_ORDER
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\WebOrderType[]
     */
    public $WEB_ORDER;
    /**
     * Constructor method for WebOrdersContainerType
     * @uses WebOrdersContainerType::setWEB_ORDER()
     * @param \StructType\WebOrderType[] $wEB_ORDER
     */
    public function __construct(array $wEB_ORDER = array())
    {
        $this
            ->setWEB_ORDER($wEB_ORDER);
    }
    /**
     * Get WEB_ORDER value
     * @return \StructType\WebOrderType[]|null
     */
    public function getWEB_ORDER()
    {
        return $this->WEB_ORDER;
    }
    /**
     * This method is responsible for validating the values passed to the setWEB_ORDER method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWEB_ORDER method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWEB_ORDERForArrayConstraintsFromSetWEB_ORDER(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $webOrdersContainerTypeWEB_ORDERItem) {
            // validation for constraint: itemType
            if (!$webOrdersContainerTypeWEB_ORDERItem instanceof \StructType\WebOrderType) {
                $invalidValues[] = is_object($webOrdersContainerTypeWEB_ORDERItem) ? get_class($webOrdersContainerTypeWEB_ORDERItem) : sprintf('%s(%s)', gettype($webOrdersContainerTypeWEB_ORDERItem), var_export($webOrdersContainerTypeWEB_ORDERItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WEB_ORDER property can only contain items of type \StructType\WebOrderType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WEB_ORDER value
     * @throws \InvalidArgumentException
     * @param \StructType\WebOrderType[] $wEB_ORDER
     * @return \StructType\WebOrdersContainerType
     */
    public function setWEB_ORDER(array $wEB_ORDER = array())
    {
        // validation for constraint: array
        if ('' !== ($wEB_ORDERArrayErrorMessage = self::validateWEB_ORDERForArrayConstraintsFromSetWEB_ORDER($wEB_ORDER))) {
            throw new \InvalidArgumentException($wEB_ORDERArrayErrorMessage, __LINE__);
        }
        $this->WEB_ORDER = $wEB_ORDER;
        return $this;
    }
    /**
     * Add item to WEB_ORDER value
     * @throws \InvalidArgumentException
     * @param \StructType\WebOrderType $item
     * @return \StructType\WebOrdersContainerType
     */
    public function addToWEB_ORDER(\StructType\WebOrderType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WebOrderType) {
            throw new \InvalidArgumentException(sprintf('The WEB_ORDER property can only contain items of type \StructType\WebOrderType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WEB_ORDER[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WebOrdersContainerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
